/* This is the LiveJournal flat protocol file. Whee.

	The object name has to exactly match the <accounttype> value, as it is what is called when the login button is hit. The entry function is .startLogin().
	
	This is the LiveJournal object. Upon completion of logging in, these variables will be available:
	
	.username = The username of the user. Duh.
	.password = The current password of the user. I should keep it as a hexMD5 thing, but ffs, I'm having enough trouble as it is.
	.posturl = The URL to the XML-RPC interface.
	.fullname = The full name of the user (set in their user info). Do what you want with it.
	.moods[] = An array of all the moods that LJ has.
	.moods[x].id = The mood ID. You need to send this instead of the mood name if it is available, otherwise the user won't get little happy icons
		next to their moods.
	.moods[x].mood = The text value of the mood. "Happy," "angry," "horny," "ya mum," whatever. These are cached for each individual account, as different servers
		may have different moods (ie, user might have a LiveJournal and a DeadJournal account.
	.moods[x].parentmood = The ID of the mood that the mood is based on. Make sense? Didn't to me either. This doesn't really get used anywhere,
		but I thought I should keep it just in case there's some amazingly amazing function to use in the future.
	.defaultpicurl = The URL of the default userpic for the user. Attach it to an <image> tag, and viola, pretty user pic!
	.friendgroups[] = An array of the friends groups.
	.friendgroups[x].name = The name of the security group. eg. "everyone but my girlfriend" or something.
	.friendgroups[x].id = This is a genuine crackwhore to do. Well, it was in the flat interface. Looks like you just have to add the numbers together
		to create a hash now. Anyway, this is the ID of the security group. Check the protocol docs for more info.
	.friendgroups[x]sortorder = What order the groups should appear in. Honestly, who cares?
	.friendgroups[x].ispublic = If the group is public or not. As stated before, who cares?
	.usejournals[] = An array holding strings of journals that the user can post to. Easy.
	.pickws[] = Another array, this one being picture keywords.
	.pickkws[x].pickw = The keyword of the picture to attach to the post.
	.pickws[x].url = The URL of the picture of the keyword to attach. Makes for nice little selection boxes.
	
	These should be all the variables you need. Well, they're all the variables there are, minus the menus, but they're utterly useless, and I'll save
		that for a rainy day. Enjoy.
	
	NOTE: If you need to read additional values from the XML file, make sure they're set up in the Account Wizard! (accwiz.js) There is a function in there
		called ExtraTags() - add what you need to the switch statement there. And don't forget to add the object to the drop-down menu in accwiz.xul.
	
	Oh, and don't forget to reference this file from deepestsender.xul. Because you'd be an idiot if you didn't.
	
	And finally, you have an object to play with - status. Its just a reference to a label tag at the bottom of the login screen, and you can set
		status.value to whatever the hell you want to inform the user on how logging in is progressing, or that they suck monkey nuts, or anything!

*/
LiveJournal = new Object();
LiveJournal.retrycount = 0;
const ljbundle = document.getElementById("livejournalbundle");

LiveJournal.startLogin = function() {
	// All blog objects need to have this function. It is what is called when the login button is hit.
	// In: Nothing.
	// Out: Nothing.
	this.username = dsAccounts.username;
	this.password = dsAccounts.password;
	this.posturl = dsAccounts.posturl;
	var cookie = GetTag(dsAccounts.currentaccount, "cookie");
	this.bindtoip = cookie.getAttribute("bindtoip");
	this.expiration = cookie.getAttribute("expires");
	this.domain = GetTag(dsAccounts.currentaccount, "posturl").getAttribute("domain");
	var usechallenge = GetTag(dsAccounts.currentaccount, "cookie").getAttribute("challenge");

	var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var ljdomain = "http://" + LiveJournal.domain;
	var ljuri = nsiio.newURI(ljdomain, null, null);
	var cookieservice = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieService);
	var cookiestring = cookieservice.getCookieString(ljuri, null);
	var cookiearray = cookiestring.split("; ");
	for (i = 0; i < cookiearray.length; i++) {
		var ljsessionrx = new RegExp("ljsession=.*", "gi");
		if (ljsessionrx.test(cookiearray[i])) {
			this.doLogin();
			return;
		}
	}
	
	if (usechallenge == "true") {
		this.requestChallenge();
	} else {
		this.makeSession();
	}
}

LiveJournal.requestChallenge = function() {
	// This connects to the LJ server and requests a challenge (bunch of numbers/letters) from the server. A response is generated, from the user's
	// password, then sent back to the server. Basically near-impossible to crack.
	// In: Nothing.
	// Out: Nothing. Note that .challengeHandler() will be called as soon as the RPC request has completed.
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.challengeHandler.onResult;
	this.httpreq.onerror = this.challengeHandler.onError;
	this.httpreq.open("POST", this.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
	status.value = ljbundle.getString("RequestingChallenge");
}

LiveJournal.challengeHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	// In: Nothing.
	// Out: Nothing, but if successful, will call the .doLogin() function.
	onResult: function() {
		if (dsAccounts.loggingin) {
			if (LiveJournal.getResponseData("success", LiveJournal.httpreq.responseText) == "OK") {
				var challenge = LiveJournal.getResponseData("challenge", LiveJournal.httpreq.responseText);
				LiveJournal.makeSession(challenge);
			} else {
				var errmsg = LiveJournal.getResponseData("errmsg", LiveJournal.httpreq.responseText);
				if (errmsg) {
					alert(ljbundle.getString("ErrorRequest") + " " + errmsg);
				} else {
					alert(ljbundle.getString("ErrorRequest") + " " + LiveJournal.httpreq.responseText);
				}
				Login();
			}
		}
	},
	onError: function () {
		if (dsAccounts.loggingin) {
			alert(ljbundle.getString("ErrorConnecting"));
			Login();
		}
	}
}

LiveJournal.makeSession = function(challengestring) {
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.sessionHandler.onResult;
	this.httpreq.onerror = this.sessionHandler.onError;
	this.httpreq.open("POST", this.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	var params = new Object();
	params.user = this.username.toLowerCase();
	if (challengestring) {
		params.auth_method = "challenge";
		params.auth_challenge = challengestring;
		params.auth_response = hexMD5(challengestring + hexMD5(this.password));
	} else {
		params.auth_method = "clear";
		params.hpassword = hexMD5(this.password);
	}
	params.expiration = LiveJournal.expiration;
	if (LiveJournal.bindtoip == "true") {
		params.ipfixed = 1;
	}
	params.ver = 1;
	var body = "mode=sessiongenerate";
	body += this.makeParams(params);
	status.value = ljbundle.getString("GeneratingSession");
	this.httpreq.send(body);
}

LiveJournal.sessionHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	// In: Nothing.
	// Out: Nothing, but if successful, will call the .doLogin() function.
	onResult: function() {
		if (dsAccounts.loggingin) {
			if (LiveJournal.getResponseData("success", LiveJournal.httpreq.responseText) == "OK") {
				var cookie = LiveJournal.getResponseData("ljsession", LiveJournal.httpreq.responseText);
				
				var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var ljdomain = "http://" + LiveJournal.domain;
				var ljuri = nsiio.newURI(ljdomain, null, null);
				var cookieservice = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieService);
				cookie = "ljsession=" + cookie;
				cookie += "; domain=." + LiveJournal.domain;
				if (LiveJournal.expiration == "long") {
					var now = new Date();
					now.setDate(60);
					var expires = "; expires=" + now.toGMTString(); 
					cookie += expires;
				}
				cookieservice.setCookieString(ljuri, null, cookie, null); 
				
				LiveJournal.doLogin(cookie);
			} else {
				var errmsg = LiveJournal.getResponseData("errmsg", LiveJournal.httpreq.responseText);
				if (errmsg) {
					alert(ljbundle.getString("ErrorRequest") + " " + errmsg);
				} else {
					alert(ljbundle.getString("ErrorRequest") + " " + LiveJournal.httpreq.responseText);
				}
				Login();
			}
		}
	},
	onError: function () {
		if (dsAccounts.loggingin) {
			alert(ljbundle.getString("ErrorConnecting"));
			Login();
		}
	}
}

LiveJournal.doLogin = function(ljsession) {
	// Seriously having second thoughts that XML-RPC would be easier to use than just the flat interface. Anyway, this generates a login request to
	//	the server. All sorts of goodies in here. Also loads up cached moods, makes a response from the challenge, blah blah.
	// In: The challenge string.
	// Out: Nothing, but it'll launch off another request that calls .loginHandler() when it completes.
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.loginHandler.onResult;
	this.httpreq.onerror = this.loginHandler.onError;
	this.httpreq.open("POST", this.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.setRequestHeader("X-LJ-Auth", "cookie");
	var params = new Object();
	// Goddamn mood list stuff. Bane of my existence, other than lj-cut tags.
	this.moods = [];
	var moodnodes = GetTag(dsAccounts.currentaccount, "moods");
	this.highestmood = parseInt(moodnodes.getAttribute("highestmood"), 10);
	for (i = 0; i < moodnodes.childNodes.length; i++) {
		this.moods[i] = [];
		this.moods[i].mood = moodnodes.childNodes[i].getAttribute("name");
		this.moods[i].id = moodnodes.childNodes[i].getAttribute("moodid");
		this.moods[i].parentmood = moodnodes.childNodes[i].getAttribute("parent");
	}
	params.getmoods = this.highestmood;
	var defsectag = GetTag(dsAccounts.currentaccount, "security");
	this.defaultsecurity = defsectag.getAttribute("level");
	this.defaultgroups = defsectag.getAttribute("groups");
	var defaultoptions = GetTag(dsAccounts.currentaccount, "options");
	this.defaultbackdate = defaultoptions.getAttribute("backdate");
	this.defaultdontautoformat = defaultoptions.getAttribute("dontautoformat");
	this.defaultremovecomments = defaultoptions.getAttribute("removecomments");
	params.user = this.username.toLowerCase();
	params.auth_method = "cookie";

	params.ver = 1;
	params.clientversion = AppName;
	params.getpickws = 1;
	params.getpickwurls = 1;
	
	var body = "mode=login";
	body += this.makeParams(params);
	status.value = ljbundle.getString("SendingLoginRequest");
	this.httpreq.send(body);
}

LiveJournal.loginHandler = {
	// This is stupid. There has to be a way I can re-use all this stuff. This function processes the response from the server for logging in.
	// In: Nothing.
	// Out: Nothing. It will call FinaliseLogin() (in deepestsender.js), which is the last function that runs before handing control over to
	//	the blog window. Make sure you add this line.
	onResult: function() {
		if (dsAccounts.loggingin) {
			if (LiveJournal.getResponseData("success", LiveJournal.httpreq.responseText) == "OK") {
				var result = LiveJournal.httpreq.responseText;
				status.value = ljbundle.getString("ProcessingLoginResult");
				LiveJournal.fullname = LiveJournal.getResponseData("fullname", result);
				LiveJournal.defaultpicurl = LiveJournal.getResponseData("defaultpicurl", result);
				var fastserver = parseInt(LiveJournal.getResponseData("fastserver", result), 10);
				var message = LiveJournal.getResponseData("message", result);
				var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var ljuri = nsiio.newURI("http://" + LiveJournal.domain, null, null);
				if (fastserver) {
					var cookieservice = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieService);
					var cookie = "ljfastserver=1; domain=." + LiveJournal.domain;
					cookieservice.setCookieString(ljuri, null, cookie, null); 
				}
				LiveJournal.friendgroups = [];
				for (i = 1; i <= parseInt(LiveJournal.getResponseData("frgrp_maxnum", result), 10); i++) {
					var fgroup = LiveJournal.getResponseData("frgrp_" + i+ "_name", result);
					if (fgroup) {
						var fgend = LiveJournal.friendgroups.push([]);
						fgend--;
						LiveJournal.friendgroups[fgend].name = fgroup;
						LiveJournal.friendgroups[fgend].id = i;
						LiveJournal.friendgroups[fgend].sortorder = LiveJournal.getResponseData("frgrp_" + i + "_sortorder", result);
						LiveJournal.friendgroups[fgend].ispublic = LiveJournal.getResponseData("frgrp_" + i + "_public", result);
					}
				}
				LiveJournal.usejournals = [];
				for (i = 1; i <= parseInt(LiveJournal.getResponseData("access_count", result), 10); i++) {
					LiveJournal.usejournals[i - 1] = LiveJournal.getResponseData("access_" + i, result);
				}
				status.value = ljbundle.getString("SortingMoods");
				// Bah. More moods crap.
				var moodsxml = dsAccounts.dsXML.createDocumentFragment();
				var moodsxmlnode = moodsxml.appendChild(GetTag(dsAccounts.currentaccount, "moods").cloneNode(true));
				var j = LiveJournal.moods.length;
				for (i = 1; i <= parseInt(LiveJournal.getResponseData("mood_count", result), 10); i++) {
					dump("loop " + i + ", adding to " + j + "\n\n");
					LiveJournal.moods[j] = [];
					LiveJournal.moods[j].mood = LiveJournal.getResponseData("mood_" + i + "_name", result);
					LiveJournal.moods[j].id = LiveJournal.getResponseData("mood_" + i + "_id", result);
					if (parseInt(LiveJournal.highestmood) < parseInt(LiveJournal.moods[j].id)) {
						LiveJournal.highestmood = LiveJournal.moods[j].id;
					}
					moodsxmlnode.appendChild(dsAccounts.dsXML.createElement("mood"));
					moodsxmlnode.lastChild.setAttribute("name", LiveJournal.moods[j].mood);
					moodsxmlnode.lastChild.setAttribute("moodid", LiveJournal.moods[j].id);
					//moodsxmlnode.lastChild.setAttribute("parent", LiveJournal.moods[j].parentid);
					j++;
				}
				moodsxmlnode.setAttribute("highestmood", LiveJournal.highestmood);
				var oldmood = GetTag(dsAccounts.currentaccount, "moods");
				if (parseInt(LiveJournal.getResponseData("mood_count", result), 10) > 0) {
					dsAccounts.currentaccount.replaceChild(moodsxml, oldmood);
				}
				
				dsAccounts.saveSettings();
				// Now to get the moods in alphabetical order.
				var temp;
				for (i = 0; i < LiveJournal.moods.length; i++) {
					for (j = 0; j < LiveJournal.moods.length -1; j++) {
						if (LiveJournal.moods[j].mood.toString() > LiveJournal.moods[j+1].mood.toString()) {
							temp = LiveJournal.moods[j];
							LiveJournal.moods[j] = LiveJournal.moods[j+1];
							LiveJournal.moods[j+1] = temp;
						}
					}
				}
				LiveJournal.pickws = [];
				for (i = 1; i <= parseInt(LiveJournal.getResponseData("pickw_count", result), 10); i++) {
					LiveJournal.pickws[i - 1] = [];
					LiveJournal.pickws[i - 1].pickw = LiveJournal.getResponseData("pickw_" + i, result);
					LiveJournal.pickws[i - 1].url = LiveJournal.getResponseData("pickwurl_" + i, result);
				}
				if (message) {
					status.value = ljbundle.getString("DisplayingServerMessages");
					alert(message);
				}
				status.value = ljbundle.getString("LoggedIn");
				
				if (GetTag(dsAccounts.currentaccount, "accounttype").getAttribute("usetags") == "true") {
					LiveJournal.usetags = true;
				}
				document.getElementById("dsPostFrame").setAttribute("src", "protocols/livejournal/livejournal.xul");
				LiveJournal.retrycount = 0;
				FinaliseLogin(LiveJournal);
			} else {
				var errmsg = LiveJournal.getResponseData("errmsg", LiveJournal.httpreq.responseText);
				if ((errmsg == "Invalid password") && (LiveJournal.retrycount < 1)) {
					var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
					var ljuri = "." + LiveJournal.domain;
					var cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
					cookiemanager.remove(ljuri, "ljsession", "/", false);
					LiveJournal.retrycount++;
					Login();
					Login();
				} else {
					if (errmsg) {
						alert(ljbundle.getString("ErrorRequest") + " " + errmsg);
					} else {
						alert(ljbundle.getString("ErrorRequest") + " " + LiveJournal.httpreq.responseText);
					}
					LiveJournal.retrycount = 0;
					Login();
				}
			}
		}
	},
	onError: function () {
		if (dsAccounts.loggingin) {
			alert(ljbundle.getString("ErrorConnecting"));
			LiveJournal.retrycount = 0;
			Login();
		}
	}
}

LiveJournal.makeParams = function(paramobj) {
	// Sticks all the variables in an object into a long string that looks like: &variablename=variablevalue&variablename2=variablevalue2, and so on,
	//	for posting to LJ as flat. URIencodes them too for unicode.
	// In: An object.
	// Out: A string that looks like what I just wrote before.
	var body = "";
	for (i in paramobj) {
		var paramstring = "&" + encodeURIComponent(i) + "=" + encodeURIComponent(paramobj[i]);
		body += paramstring;
	}
	return body;
}

LiveJournal.getResponseData = function(heading, responseText, removeplussigns) {
	// Runs through the response send by the flat interface and finds the value corresponding to what was requested.
	// In: The variable to look up, the text to search through for it.
	// Out: The value of the variable, or null if it isn't found.
	var i = 0;
	var data = null;

	try {
		var responseData = responseText.split("\n");
	} catch(e) {
		return "";
	}

	while (i != responseData.length) {
		if (responseData[i] == heading) {
			data = responseData[i + 1];
			if (removeplussigns) {
				data = data.replace(/\+/gi, "%20");
			}
			try {
				data = decodeURIComponent(data);
			} catch(e) {
				dump("\nmessed up decoding line, returning original text...");
			}
			return data;
		}
		i++;
	}

	return null;
}
