ljPost = window.arguments[0];
LiveJournal = window.arguments[1];

function Init() {
	// Main init function, runs when the window is opened. Reads the mask.
	// In: Nothing.
	// Out: Nothing.
	var groupbox = document.getElementById("allowmask");
	for (i = 0; i < LiveJournal.friendgroups.length; i++) {
		groupbox.appendItem(LiveJournal.friendgroups[i].name, LiveJournal.friendgroups[i].id);
		groupbox.lastChild.setAttribute("type", "checkbox");
		var ischecked = BreakMask(ljPost.allowmask, parseInt(LiveJournal.friendgroups[i].id), 10);
		groupbox.lastChild.setAttribute("checked", ischecked);
	}
	if (LiveJournal.friendgroups.length < 1) {
		document.getElementById("friendsbox").selectedIndex = 1;
	}	
}

function OkClicked() {
	// Runs when OK is clicked. Sets the mask to use.
	// In: Nothing.
	// Out: Nothing.
	ljPost.allowmask = 0;
	var groupbox = document.getElementById("allowmask");
	for (i = 0; i < groupbox.childNodes.length; i++) {
		if (groupbox.childNodes[i].checked) {
			ljPost.allowmask = MakeMask(ljPost.allowmask, parseInt(groupbox.childNodes[i].value, 10));
		}
	}
}

function MakeMask(mainmask, addbit) {
	// Creates the mask number to use.
	// In: The actual mask number as it is now, and the bit number to turn on.
	// Out: The mask, with the bit turned on.
	var z = MakeGroupMaskNumber(addbit);
	var newmask = mainmask | z;
	return newmask;
}

function BreakMask(mainmask, addbit) {
	// Returns true if specified bit number is on, false if it isn't.
	// In: The mask to use to compare, the bit number to check if it is turned on.
	// Out: True if the bit is on, false if it isn't.
	var z = MakeGroupMaskNumber(addbit);
	var testmask = mainmask & z;
	if (testmask == z) {
		return true;
	}
	return false;
}

function MakeGroupMaskNumber(zerolength) {
	// Returns a number with the bit turned on however many zeros across is specified.
	// In: A number. ie. 4 will return 10000 as a base 10 integer.
	// Out: The number created. See above.
	var binstring = "";
	for (x = 0; x < zerolength; x++) {
		binstring += "0";
	}
	binstring = "1" + binstring;
	return parseInt(binstring, 2);
}
